loci.formats.services

## Interface JHDFService

- All Superinterfaces:
    loci.common.services.Service
  All Known Implementing Classes:
    JHDFServiceImpl

      public interface JHDFService
      extends loci.common.services.Service

  Utility class for working with NetCDF/HDF files.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes and resets the service.
    `void` | `createGroup(java.lang.String path)` Writes an array as sub-slice into an existing HDF5 dataset
    `boolean` | `exists(java.lang.String path)` Checks if path in HDF5 file exists.
    `int` | `getElementSize(java.lang.String path)` Retrieves the Element Size of a dataset in Byte.
    `java.lang.String` | `getFile()` Retrieves the current initialized file path.
    `java.util.List<java.lang.String>` | `getMember(java.lang.String path)` Retrieves the all members of a group.
    `int[]` | `getShape(java.lang.String path)` Retrieves the shape of a dataset.
    `void` | `initIntArray(java.lang.String path, long[] dimensions, long bpp)` Creates an HDF5 dataset in path consisting of integers specified by bytes per pixel bpp.
    `ch.systemsx.cisd.base.mdarray.MDByteArray` | `readByteArray(java.lang.String path)` Reads a multi-dimensional byte array from path.
    `ch.systemsx.cisd.base.mdarray.MDByteArray` | `readByteBlockArray(java.lang.String path, int[] offset, int[] size)` Reads a multi-dimensional sub-block byte array from path.
    `ch.systemsx.cisd.hdf5.HDF5CompoundDataMap[]` | `readCompoundArrayDataMap(java.lang.String path)` Reads Compound array of any type
    `ch.systemsx.cisd.base.mdarray.MDIntArray` | `readIntArray(java.lang.String path)` Reads a multi-dimensional int array from path.
    `ch.systemsx.cisd.base.mdarray.MDIntArray` | `readIntBlockArray(java.lang.String path, int[] offset, int[] size)` Reads a multi-dimensional sub-block int array from path.
    `ch.systemsx.cisd.base.mdarray.MDShortArray` | `readShortBlockArray(java.lang.String path, int[] offset, int[] size)` Reads a multi-dimensional sub-block short array from path.
    `java.lang.String[]` | `readStringArray(java.lang.String path)` Reads String array array from path.
    `void` | `setFile(java.lang.String file)` Initializes the service on a given file path.
    `void` | `setFileForWrite(java.lang.String file)` Initializes the service on a given file path.
    `void` | `writeArraySlice(java.lang.String path, ch.systemsx.cisd.base.mdarray.MDByteArray image, long[] offset)` Writes an array as sub-slice into an existing HDF5 dataset
    `void` | `writeArraySlice(java.lang.String path, ch.systemsx.cisd.base.mdarray.MDIntArray image, long[] offset)` Writes an array as sub-slice into an existing HDF5 dataset
    `void` | `writeArraySlice(java.lang.String path, ch.systemsx.cisd.base.mdarray.MDShortArray image, long[] offset)` Writes an array as sub-slice into an existing HDF5 dataset

- - ### Method Detail

    - #### setFile

          void setFile(java.lang.String file)
                throws java.io.IOException

      Initializes the service on a given file path.
      Parameters:
        `file` - Path to initialize the service with.
      Throws:
        `java.io.IOException` - If there is an error initializing the service with `file`.

    - #### setFileForWrite

          void setFileForWrite(java.lang.String file)
                        throws java.io.IOException

      Initializes the service on a given file path.
      Parameters:
        `file` - Path to initialize the service with.
      Throws:
        `java.io.IOException` - If there is an error initializing the service with `file`.

    - #### getFile

          java.lang.String getFile()

      Retrieves the current initialized file path.
      Returns:
        Current initialized file path or `null` if the service has yet to be initialized or is closed.

    - #### getShape

          int[] getShape(java.lang.String path)

      Retrieves the shape of a dataset.
      Parameters:
        `path` - HDF path to the dataset.
      Returns:
        int[] of shapes.

    - #### getMember

          java.util.List<java.lang.String> getMember(java.lang.String path)

      Retrieves the all members of a group.
      Parameters:
        `path` - HDF path to the group.
      Returns:
        List of members.

    - #### getElementSize

          int getElementSize(java.lang.String path)

      Retrieves the Element Size of a dataset in Byte.
      Parameters:
        `path` - HDF path to the group.
      Returns:
        List of members.

    - #### readByteArray

          ch.systemsx.cisd.base.mdarray.MDByteArray readByteArray(java.lang.String path)

      Reads a multi-dimensional byte array from path.
      Parameters:
        `path` - HDF path to the dataset.
      Returns:
        MDByteArray array of bytes.

    - #### readIntArray

          ch.systemsx.cisd.base.mdarray.MDIntArray readIntArray(java.lang.String path)

      Reads a multi-dimensional int array from path.
      Parameters:
        `path` - HDF path to the dataset.
      Returns:
        MDIntArray array of int.

    - #### readIntBlockArray

          ch.systemsx.cisd.base.mdarray.MDIntArray readIntBlockArray(java.lang.String path,
                                                                     int[] offset,
                                                                     int[] size)

      Reads a multi-dimensional sub-block int array from path.
      Parameters:
        `path` - HDF path to the dataset.
        `offset` - Offset of the block to read.
        `size` - Output size of the array.
      Returns:
        MDIntArray array of int.

    - #### readByteBlockArray

          ch.systemsx.cisd.base.mdarray.MDByteArray readByteBlockArray(java.lang.String path,
                                                                       int[] offset,
                                                                       int[] size)

      Reads a multi-dimensional sub-block byte array from path.
      Parameters:
        `path` - HDF path to the dataset.
        `offset` - Offset of the block to read.
        `size` - Output size of the array.
      Returns:
        MDIntArray array of int.

    - #### readShortBlockArray

          ch.systemsx.cisd.base.mdarray.MDShortArray readShortBlockArray(java.lang.String path,
                                                                         int[] offset,
                                                                         int[] size)

      Reads a multi-dimensional sub-block short array from path.
      Parameters:
        `path` - HDF path to the dataset.
        `offset` - Offset of the block to read.
        `size` - Output size of the array.
      Returns:
        MDIntArray array of int.

    - #### readStringArray

          java.lang.String[] readStringArray(java.lang.String path)

      Reads String array array from path.
      Parameters:
        `path` - HDF path to the dataset.
      Returns:
        String[] array.

    - #### readCompoundArrayDataMap

          ch.systemsx.cisd.hdf5.HDF5CompoundDataMap[] readCompoundArrayDataMap(java.lang.String path)

      Reads Compound array of any type
      Parameters:
        `path` - HDF path to the dataset.
      Returns:
        HDF5CompoundDataMap[] compound array map.

    - #### exists

          boolean exists(java.lang.String path)

      Checks if path in HDF5 file exists.
      Parameters:
        `path` - path to HDF5 group or dataset.
      Returns:
        boolean true if path exists in HDF5 file else false.

    - #### initIntArray

          void initIntArray(java.lang.String path,
                            long[] dimensions,
                            long bpp)

      Creates an HDF5 dataset in path consisting of integers specified by bytes per pixel bpp.
      Parameters:
        `path` - path to HDF5 a dataset.
        `bpp` - bytes per pixel for the integer data type bpp \in {1,2,4} == {Byte, Short, Integer}

    - #### writeArraySlice

          void writeArraySlice(java.lang.String path,
                               ch.systemsx.cisd.base.mdarray.MDByteArray image,
                               long[] offset)

      Writes an array as sub-slice into an existing HDF5 dataset
      Parameters:
        `path` - path to the (existing) HDF5 dataset.
        `image` - the data stored as MDArray of pixel type Byte
        `offset` - dimensions, where to start writing the image. The image will be written from offset to offset + image.dimensions()

    - #### writeArraySlice

          void writeArraySlice(java.lang.String path,
                               ch.systemsx.cisd.base.mdarray.MDShortArray image,
                               long[] offset)

      Writes an array as sub-slice into an existing HDF5 dataset
      Parameters:
        `path` - path to the (existing) HDF5 dataset.
        `image` - the data stored as MDArray of pixel type Short
        `offset` - dimensions, where to start writing the image. The image will be written from offset to offset + image.dimensions()

    - #### writeArraySlice

          void writeArraySlice(java.lang.String path,
                               ch.systemsx.cisd.base.mdarray.MDIntArray image,
                               long[] offset)

      Writes an array as sub-slice into an existing HDF5 dataset
      Parameters:
        `path` - path to the (existing) HDF5 dataset.
        `image` - the data stored as MDArray of pixel type int
        `offset` - dimensions, where to start writing the image. The image will be written from offset to offset + image.dimensions()

    - #### createGroup

          void createGroup(java.lang.String path)
                    throws java.io.IOException

      Writes an array as sub-slice into an existing HDF5 dataset
      Parameters:
        `path` - path of the HDF5 group.
      Throws:
        `java.io.IOException`

    - #### close

          void close()
              throws java.io.IOException

      Closes and resets the service.
      Throws:
        `java.io.IOException` - If there is an error closing the file.

Copyright © 2026 Open Microscopy Environment